#include <bits/stdc++.h>
using namespace std;
long long L,R,N,Q,k,br,c;
int maks;
long long a[500022];
int mat[25][500011];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> N >> Q;

    for(int i=1;i<=N;i++){
        cin >> a[i];
        k=1<<20;
        br=20;
        while(true){
            if(a[i]&k){
                mat[br][i]++;
                break;
            }
            br--;
            k>>=1;
        }
    }

    for(int i=0;i<=20;i++){ ///
        for(int j=2;j<=N;j++){
            mat[i][j]+=mat[i][j-1];
        }
    }
    while(Q--){
        cin >> L >> R;
        maks=0;
        for(int i=0;i<=20;i++){
            if(mat[i][R]-mat[i][L-1]>maks)
                maks=mat[i][R]-mat[i][L-1];
        }
        cout << maks<< "\n";

    }




}